function makeSymbolConsole()
    
    symbolConsole = DevConsole("UTF-8 Symbols")
    symbolConsole:print(DevConsole.ICON_DOWN_ARROW_TO_BAR, " Downwards Arrow To Bar") -- Downwards Arrow To Bar
    symbolConsole:print(DevConsole.ICON_DOWN_ARROW_FROM_BAR, " Downwards Arrow From Bar") -- Downwards Arrow From Bar
    symbolConsole:print(DevConsole.ICON_DOWN_WHITE_ARROW, " Downwards White Arrow") -- Downwards White Arrow
    symbolConsole:print(DevConsole.ICON_CLOSED_LOCK, " Closed Lock") -- Closed Lock
    symbolConsole:print(DevConsole.ICON_OPEN_LOCK, " Open Lock") -- Open Lock
    symbolConsole:print(DevConsole.ICON_BULLSEYE, " Bullseye") -- Bullseye
    symbolConsole:print(DevConsole.ICON_WHITE_SCISSORS, " White Scissor") -- White Scissors
    symbolConsole:print(DevConsole.ICON_UPPER_BLADE_SCISSORS, " Upper Blade Scissors") -- Upper Blade Scissors
    symbolConsole:print(DevConsole.ICON_LOWER_RIGHT_PENCIL," Lower Right Pencil") -- Lower Right Pencil
    symbolConsole:print(DevConsole.ICON_NEXT_PAGE, " Next Page") -- Next Page
    symbolConsole:print(DevConsole.ICON_CLEAR_SCREEN, " Clear Screen") -- Clear Screen
    symbolConsole:print(DevConsole.ICON_PRINT_SCREEN, " Print Screen") -- Print Screen
    symbolConsole:print(DevConsole.ICON_ARROW_IN_BOX, " Arrow In Box") -- Downwards Arrow in Box / APL Functional Symbol Quad Downwards Arrow
   
end

function testPrints(console)
    local a,b,t = "A", "B", {"a","b",c="c"}
    console:print("Test print()",a,b,t)
    console:printc(color(255,0,0),"test printc()",a,b,t)
    console:printcs("Test printcs()",a,b,t)
    console:printIf(1==1,"Test printIf()",a,b,t)
    console:printIfc(1==1,color(255,0,0),"test printIfc",a,b,t)
    console:prints("Test prints()",a,b,t)
    console:printt("Test printt()",a,b,t)
    console:printtc("Test printtc()",a,b,t)
    console:printtcs("Test printtcs()",a,b,t)
    console:printtn("Test printtn()",a,b,t)
end

function testConsole()
    rgbConsole = DevConsole{DevConsole.THEME_BLACKBOARD,firstLine="And so it begins...",timeFormat=DevConsole.ALT_TIMESTAMP_MICROSECS}
    rgbConsole:logPalette()
    
    local myColor = rgbConsole:createPrintColor(color(255,0,100))
    local myIndex = rgbConsole:createPrintColor(5)
    rgbConsole:print("-----------------")
    rgbConsole:print("a","b",3,myIndex)
    
    testPrints(rgbConsole)
end

function optionDump()
    testConsole = DevConsole("Option Dump")
    local t = {}
    for k,v in pairs(DevConsole) do if string.match(k, "^get") then
        table.insert(t,{k=k,f=string.gsub(k,"^[gs]et","")})
    end end
    table.sort(t, function(a,b) return a.f < b.f or (a.f == b.f and a.k < b.k) end )
    for i,v in ipairs(t) do testConsole:print(v.f:gsub("^%u", string.lower)," / ","get" .. v.f, " / set" ..v.f) end
end

function testGetThemes()
    return {--[ [
                DevConsole.THEME_DESERT_SANDS,
                DevConsole.THEME_NIGHT_SKY,
                DevConsole.THEME_LIGHT, 
                DevConsole.THEME_DARK,
                DevConsole.THEME_DRACULA, 
                DevConsole.THEME_SOLARIZED_BLUE, 
                DevConsole.THEME_SOLARIZED_GOLD, 
                DevConsole.THEME_SOLARIZED_LIGHT, 
                DevConsole.THEME_SOLARIZED_LIGHTER,
                DevConsole.THEME_ZEN_BURN_1,
                DevConsole.THEME_ZEN_BURN_2,
                DevConsole.THEME_ZEN_BURN_3,
                DevConsole.THEME_OCEAN,
                DevConsole.THEME_FOREST,
                DevConsole.THEME_OUTER_SPACE,
                DevConsole.THEME_GRAYISH,
                DevConsole.THEME_FLOWERS,
                DevConsole.THEME_ROSES,
                DevConsole.THEME_FROGS,
                DevConsole.THEME_SUNSET,
                DevConsole.THEME_STORMY_NIGHT,
                DevConsole.THEME_SPIDERMAN,
                DevConsole.THEME_SUPERMAN,
                DevConsole.THEME_WONDER_WOMAN,
                DevConsole.THEME_BATMAN,--]]
                DevConsole.THEME_WHITEBOARD,
                DevConsole.THEME_BLACKBOARD,
                -- TODO: HALLOWEEN, EASTER, CHRISTMAS
            }
end

-- Add to Main draw()

function testFilters(test,count)
    if #DevConsole.CONSOLES > 1 then
        if not filteredConsole then
            filteredConsole = DevConsole.CONSOLES[#DevConsole.CONSOLES]
            filteredConsole:printWithColor(true,"This is the filtered console")
        end
        test = test or os.time() % 2
        count = count or 20 -- Change the filter every count lines
        local rnd = math.random()
        local doing = "Showing"
        if test == 1 then doing = "Highlighting" end
        if #filteredConsole.buffer % count == 5 then
            filteredConsole:setColorFilter()
            filteredConsole:setDisplayFilter()
            if rnd < 0.15 then
                local first = filteredConsole.buffer[1].tim
                local last = filteredConsole.buffer[#filteredConsole.buffer].tim
                local lo = math.random(first,last)
                local hi = math.random(lo,last)
                filteredConsole:printWithColor(true,doing, " ",os.date(filteredConsole.timeFormat,lo)," to ",os.date(filteredConsole.timeFormat, hi))
                if test == 1 then 
                    filteredConsole:setColorFilter(color(0,255,0),{lo,hi}) 
                else
                    local thisLine = filteredConsole.buffer[#filteredConsole.buffer].lin
                    filteredConsole:setDisplayFilter({lo,hi},{thisLine,thisLine}) 
                end
            elseif rnd < 0.3 then
                local first = filteredConsole.buffer[1].lin
                local last = filteredConsole.buffer[#filteredConsole.buffer].lin
                local lo = math.random(first,last)
                local hi = math.random(lo,last)
                filteredConsole:printWithColor(true,doing, " ",lo," to ",hi)
                if test == 1 then 
                    filteredConsole:setColorFilter(color(255,0,0),{lo,hi}) 
                else
                    local thisLine = filteredConsole.buffer[#filteredConsole.buffer].lin
                    filteredConsole:setDisplayFilter({lo,hi},{thisLine,thisLine}) 
                end
            elseif rnd < 90.5 then 
                filteredConsole:printWithColor(color(200,200,0),doing, " bugs!")
                if true or test == 1 then 
                    filteredConsole:setColorFilter(color(255,255,0),"[bB]ugs") 
                else
                    filteredConsole:setDisplayFilter("[Bb]ugs") 
                end
            elseif rnd < 0.7 then 
                filteredConsole:printWithColor(color(200,0,200),doing, " Dogs and Hogs!")
                if test == 1 then 
                    filteredConsole:setColorFilter(color(255,0,255),"[hHdD]ogs")
                else
                    filteredConsole:setDisplayFilter("[DdHh]ogs")
                end
            elseif rnd < 0.9 then
                filteredConsole:printWithColor(color(0,200,200),doing, " ?ugs and ?ats!")
                if test == 1 then 
                    filteredConsole:setColorFilter(color(0,255,255),"ugs","ats")
                else
                    filteredConsole:setDisplayFilter("ugs","ats")
                end
            else
                filteredConsole:printWithColor(true,"Stop ",doing)
            end
        end
    end
end